unit MSWORD;

interface
var CreatedWord:boolean;
Function CreateWord:boolean;
Function VisibleWord (visible:boolean):boolean;
Function AddDoc(name:string):variant;
Function CloseDoc(document:variant):boolean;
Function CloseDocEx(document:variant;saved: boolean):boolean;
Function CloseWord:boolean;
Function OpenDoc(name:string):variant;
Function CopyTextDocToClipboard(doc:variant) :boolean;
Function ImportTextFromDoc(doc:variant):string;
implementation
uses
   Windows,SysUtils,ComObj, Variants;
var
   W:variant;

Function CreateWord:boolean;
//    Application
begin
  CreateWord:=True;
  CreatedWord:=True;
  try
    W:=CreateOleObject('Word.Application');
  except
    CreateWord:=False;
    CreatedWord:=False;
  end;
End;

Function VisibleWord(Visible:boolean):boolean;
//   Word
begin
   VisibleWord:=True;
   try
     W.Visible:= Visible;
   except
     VisibleWord:=False;
   end;
End;

Function AddDoc(name:string):variant;
// 
var
  Docs:variant;
begin
  AddDoc:=null;
  try
    Docs:=W.Documents;
    AddDoc:=Docs.Add(name);
  except
    AddDoc:=null;
  end;
End;

Function OpenDoc(name:string):variant;
//  
var
  Docs:variant;
begin
  OpenDoc:=True;
  try
    Docs:=W.Documents;
    OpenDoc:=Docs.Open(name);
  except
    OpenDoc:=null;
  end;
End;

Function CopyTextDocToClipboard(doc:variant):boolean;
//     
begin
  CopyTextDocToClipboard:=True;
  try
    doc.Range.Select;
    W.Selection.Copy;
  except
    CopyTextDocToClipboard:=False;
  end;
End;

Function ImportTextFromDoc(doc:variant):string;
//    Word
begin
  ImportTextFromDoc:='';
  try
    ImportTextFromDoc:=doc.Range.Text;
  except
    ImportTextFromDoc:='';
  end;
End;

// 
Function CloseDoc(document:variant):boolean;
begin
  CloseDoc:=True;
  try
    document.Close;
  except
    CloseDoc:=False;
  end;
End;

Function CloseDocEx(document:variant;saved:boolean):boolean;
begin
  CloseDocEx:=True;
  try
    document.Close(saved);
  except
    CloseDocEx:=False;
  end;
End;

Function CloseWord:boolean;
//  Word
begin
  CloseWord:=True;
  try
    W.Quit;
    W:=UnAssigned;
  except
    CloseWord:=False;
  end;
End;

end.
